Index: issm/trunk/src/m/classes/flowequation.m
===================================================================
--- issm/trunk/src/m/classes/flowequation.m	(revision 18081)
+++ issm/trunk/src/m/classes/flowequation.m	(revision 18301)
@@ -6,19 +6,22 @@
 classdef flowequation
 	properties (SetAccess=public) 
-		isSIA            = 0;
-		isSSA            = 0;
-		isL1L2           = 0;
-		isHO             = 0;
-		isFS             = 0;
-		fe_SSA           = '';
-		fe_HO            = '';
-		fe_FS            = '';
-		XTH_r            = 1.;
-		XTH_theta        = 0.;
-		vertex_equation  = NaN;
-		element_equation = NaN;
-		borderSSA        = NaN;
-		borderHO         = NaN;
-		borderFS         = NaN;
+		isSIA                          = 0;
+		isSSA                          = 0;
+		isL1L2                         = 0;
+		isHO                           = 0;
+		isFS                           = 0;
+		fe_SSA                         = '';
+		fe_HO                          = '';
+		fe_FS                          = '';
+		augmented_lagrangian_r         = 1.;
+		augmented_lagrangian_rhop      = 1.;
+		augmented_lagrangian_rlambda   = 1.;
+		augmented_lagrangian_rholambda = 1.;
+		XTH_theta                      = 0.;
+		vertex_equation                = NaN;
+		element_equation               = NaN;
+		borderSSA                      = NaN;
+		borderHO                       = NaN;
+		borderFS                       = NaN;
 	end
 	methods (Static)
@@ -59,49 +62,49 @@
 	end
 	methods
-        function createxml(obj,fid) % {{{
-            fprintf(fid, '\n\n');
-            fprintf(fid, '%s\n', '<!-- flowequation -->');
-            fprintf(fid,'%s\n%s\n%s\n','<frame key="1" label="Flow equation parameters">','<section name="flowequation" />');                    
-            
+		function createxml(obj,fid) % {{{
+			fprintf(fid, '\n\n');
+			fprintf(fid, '%s\n', '<!-- flowequation -->');
+			fprintf(fid,'%s\n%s\n%s\n','<frame key="1" label="Flow equation parameters">','<section name="flowequation" />');                    
+
 			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="isSIA" type="',              class(obj.isSIA),'" default="',                  convert2str(obj.isSIA),'">',              '     <section name="flowequation" />','     <help> is the Shallow Ice Approximation (SIA) used ? </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="isSSA" type="',            class(obj.isSSA),'" default="',                convert2str(obj.isSSA),'">',   '     <section name="flowequation" />','     <help> is the Shelfy-Stream Approximation (SSA) used ? </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="isL1L2" type="',      class(obj.isL1L2),'" default="',          convert2str(obj.isL1L2),'">',            '     <section name="flowequation" />','     <help> is the L1L2 approximation used ? </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="isHO" type="',     class(obj.isHO),'" default="',         convert2str(obj.isHO),'">',            '     <section name="flowequation" />','     <help> is the Higher-Order (HO) approximation used ? </help>','</parameter>');
-            
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="isFS" type="',       class(obj.isFS),'" default="',              convert2str(obj.isFS),'">',              '     <section name="flowequation" />','     <help> are the Full-FS (FS) equations used ? </help>','</parameter>');
-            
-            % fe_SSA drop-down (P1, P1bubble, P1bubblecondensed, P2)
-            fprintf(fid,'%s\n%s\n%s\n%s\n',    '<parameter key ="fe_SSA" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for SSA  "P1", "P1bubble" "P1bubblecondensed" "P2" </help>');
-            fprintf(fid,'%s\n','       <option value="P1" type="string" default="true"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1bubble" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1bubblecondensed" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n%s\n','       <option value="P2" type="string" default="false"> </option>','</parameter>');
-            
-            %fe_HO drop-down (P1, P1bubble, P1bubblecondensed, P1xP2, P2xP1, P2)
-            fprintf(fid,'%s\n%s\n%s\n%s\n',        '<parameter key ="fe_HO" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for HO   "P1" "P1bubble" "P1bubblecondensed" "P1xP2" "P2xP1" "P2" </help>');
-            fprintf(fid,'%s\n','       <option value="P1" type="string" default="true"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1bubble" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1bubblecondensed" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1xP2" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="P2xP1" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n%s\n','       <option value="P2" type="string" default="false"> </option>','</parameter>');
-            
-            % fe_FS drop-down (P1P1, P1P1GLS, MINIcondensed, MINI, TaylowHood)
-            fprintf(fid,'%s\n%s\n%s\n%s\n',        '<parameter key ="fe_FS" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for FS   "P1P1" (debugging only) "P1P1GLS" "MINIcondensed" "MINI" "TaylorHood" </help>');
-            fprintf(fid,'%s\n','       <option value="P1P1" type="string" default="true"> </option>');
-            fprintf(fid,'%s\n','       <option value="P1P1GLS" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="MINIcondensed" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n','       <option value="MINI" type="string" default="false"> </option>');
-            fprintf(fid,'%s\n%s\n','       <option value="TaylorHood" type="string" default="false"> </option>','</parameter>');
-            
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="vertex_equation" type="',      class(obj.vertex_equation),'" default="',            convert2str(obj.vertex_equation),'">',            '     <section name="flowequation" />','     <help> flow equation for each vertex </help>','</parameter>');
-       
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="element_equation" type="',            class(obj.element_equation),'" default="',              convert2str(obj.element_equation),'">',              '     <section name="flowequation" />','     <help> flow equation for each element </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="borderSSA" type="', class(obj.borderSSA),'" default="',   convert2str(obj.borderSSA),'">',   '     <section name="flowequation" />','     <help> vertices on SSAs border (for tiling) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="borderHO" type="',          class(obj.borderHO),'" default="',            convert2str(obj.borderHO),'">',            '     <section name="flowequation" />','     <help> vertices on HOs border (for tiling) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n',        '<parameter key ="borderFS" type="',          class(obj.borderFS),'" default="',            convert2str(obj.borderFS),'">',            '     <section name="flowequation" />','     <help> vertices on FS border (for tiling) </help>','</parameter>');
-      
-            fprintf(fid,'%s\n%s\n','</frame>');
-        end % }}}
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="isSSA" type="',            class(obj.isSSA),'" default="',                convert2str(obj.isSSA),'">',   '     <section name="flowequation" />','     <help> is the Shelfy-Stream Approximation (SSA) used ? </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="isL1L2" type="',      class(obj.isL1L2),'" default="',          convert2str(obj.isL1L2),'">',            '     <section name="flowequation" />','     <help> is the L1L2 approximation used ? </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="isHO" type="',     class(obj.isHO),'" default="',         convert2str(obj.isHO),'">',            '     <section name="flowequation" />','     <help> is the Higher-Order (HO) approximation used ? </help>','</parameter>');
+
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="isFS" type="',       class(obj.isFS),'" default="',              convert2str(obj.isFS),'">',              '     <section name="flowequation" />','     <help> are the Full-FS (FS) equations used ? </help>','</parameter>');
+
+			% fe_SSA drop-down (P1, P1bubble, P1bubblecondensed, P2)
+			fprintf(fid,'%s\n%s\n%s\n%s\n',    '<parameter key ="fe_SSA" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for SSA  "P1", "P1bubble" "P1bubblecondensed" "P2" </help>');
+			fprintf(fid,'%s\n','       <option value="P1" type="string" default="true"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1bubble" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1bubblecondensed" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n%s\n','       <option value="P2" type="string" default="false"> </option>','</parameter>');
+
+			%fe_HO drop-down (P1, P1bubble, P1bubblecondensed, P1xP2, P2xP1, P2)
+			fprintf(fid,'%s\n%s\n%s\n%s\n',        '<parameter key ="fe_HO" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for HO   "P1" "P1bubble" "P1bubblecondensed" "P1xP2" "P2xP1" "P2" </help>');
+			fprintf(fid,'%s\n','       <option value="P1" type="string" default="true"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1bubble" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1bubblecondensed" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1xP2" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="P2xP1" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n%s\n','       <option value="P2" type="string" default="false"> </option>','</parameter>');
+
+			% fe_FS drop-down (P1P1, P1P1GLS, MINIcondensed, MINI, TaylowHood)
+			fprintf(fid,'%s\n%s\n%s\n%s\n',        '<parameter key ="fe_FS" type="alternative" optional="false">','     <section name="flowequation" />','     <help> Finite Element for FS   "P1P1" (debugging only) "P1P1GLS" "MINIcondensed" "MINI" "TaylorHood" </help>');
+			fprintf(fid,'%s\n','       <option value="P1P1" type="string" default="true"> </option>');
+			fprintf(fid,'%s\n','       <option value="P1P1GLS" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="MINIcondensed" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n','       <option value="MINI" type="string" default="false"> </option>');
+			fprintf(fid,'%s\n%s\n','       <option value="TaylorHood" type="string" default="false"> </option>','</parameter>');
+
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="vertex_equation" type="',      class(obj.vertex_equation),'" default="',            convert2str(obj.vertex_equation),'">',            '     <section name="flowequation" />','     <help> flow equation for each vertex </help>','</parameter>');
+
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="element_equation" type="',            class(obj.element_equation),'" default="',              convert2str(obj.element_equation),'">',              '     <section name="flowequation" />','     <help> flow equation for each element </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="borderSSA" type="', class(obj.borderSSA),'" default="',   convert2str(obj.borderSSA),'">',   '     <section name="flowequation" />','     <help> vertices on SSAs border (for tiling) </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="borderHO" type="',          class(obj.borderHO),'" default="',            convert2str(obj.borderHO),'">',            '     <section name="flowequation" />','     <help> vertices on HOs border (for tiling) </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n',        '<parameter key ="borderFS" type="',          class(obj.borderFS),'" default="',            convert2str(obj.borderFS),'">',            '     <section name="flowequation" />','     <help> vertices on FS border (for tiling) </help>','</parameter>');
+
+			fprintf(fid,'%s\n%s\n','</frame>');
+		end % }}}
 		function obj = flowequation(varargin) % {{{
 			switch nargin
@@ -132,8 +135,11 @@
 				md = checkfield(md,'fieldname','flowequation.isHO','numel',[1],'values',[0 1]);
 				md = checkfield(md,'fieldname','flowequation.isFS','numel',[1],'values',[0 1]);
-				md = checkfield(md,'fieldname','flowequation.fe_SSA','values',{'P1','P1bubble','P1bubblecondensed','P2'});
-				md = checkfield(md,'fieldname','flowequation.fe_HO' ,'values',{'P1','P1bubble','P1bubblecondensed','P1xP2','P2xP1','P2','P1xP3','P2xP4'});
-				md = checkfield(md,'fieldname','flowequation.fe_FS' ,'values',{'P1P1','P1P1GLS','MINIcondensed','MINI','TaylorHood','XTaylorHood','OneLayerP4z'});
-				md = checkfield(md,'fieldname','flowequation.XTH_r','numel',[1],'>',0.);
+				md = checkfield(md,'fieldname','flowequation.fe_SSA','values',{'P1','P1bubble','P1bubblecondensed','P2','P2bubble'});
+				md = checkfield(md,'fieldname','flowequation.fe_HO' ,'values',{'P1','P1bubble','P1bubblecondensed','P1xP2','P2xP1','P2','P2bubble','P1xP3','P2xP4'});
+				md = checkfield(md,'fieldname','flowequation.fe_FS' ,'values',{'P1P1','P1P1GLS','MINIcondensed','MINI','TaylorHood','LATaylorHood','XTaylorHood','OneLayerP4z','CrouzeixRaviart'});
+				md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_r','numel',[1],'>',0.);
+				md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rlambda','numel',[1],'>',0.);
+				md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rhop','numel',[1],'>',0.);
+				md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rholambda','numel',[1],'>',0.);
 				md = checkfield(md,'fieldname','flowequation.XTH_theta','numel',[1],'>=',0.,'<',0.5);
 				md = checkfield(md,'fieldname','flowequation.borderSSA','size',[md.mesh.numberofvertices 1],'values',[0 1]);
@@ -144,6 +150,6 @@
 					md = checkfield(md,'fieldname','flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[1:2]);
 				elseif strcmp(domaintype(md.mesh),'2Dvertical')
-					md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[2:4]);
-					md = checkfield(md,'fieldname','flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[2:4]);
+					md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[2,4,5]);
+					md = checkfield(md,'fieldname','flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[2,4,5]);
 				elseif strcmp(domaintype(md.mesh),'3D'),
 					md = checkfield(md,'fieldname','flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[0:8]);
@@ -192,5 +198,8 @@
 			WriteData(fid,'enum',FlowequationFeHOEnum() ,'data',StringToEnum(obj.fe_HO) ,'format','Integer');
 			WriteData(fid,'enum',FlowequationFeFSEnum() ,'data',StringToEnum(obj.fe_FS) ,'format','Integer');
-			WriteData(fid,'enum',AugmentedLagrangianREnum() ,'data',obj.XTH_r ,'format','Double');
+			WriteData(fid,'enum',AugmentedLagrangianREnum(),'data',obj.augmented_lagrangian_r ,'format','Double');
+			WriteData(fid,'enum',AugmentedLagrangianRhopEnum(),'data',obj.augmented_lagrangian_rhop ,'format','Double');
+			WriteData(fid,'enum',AugmentedLagrangianRlambdaEnum(),'data',obj.augmented_lagrangian_rlambda ,'format','Double');
+			WriteData(fid,'enum',AugmentedLagrangianRholambdaEnum(),'data',obj.augmented_lagrangian_rholambda ,'format','Double');
 			WriteData(fid,'enum',AugmentedLagrangianThetaEnum() ,'data',obj.XTH_theta ,'format','Double');
 			WriteData(fid,'object',obj,'fieldname','borderSSA','format','DoubleMat','mattype',1);
@@ -202,10 +211,11 @@
 			pos=find(data==1); data(pos,end)=SIAApproximationEnum();
 			pos=find(data==2); data(pos,end)=SSAApproximationEnum();
-			pos=find(data==3); data(pos,end)=HOApproximationEnum();
-			pos=find(data==4); data(pos,end)=FSApproximationEnum();
-			pos=find(data==5); data(pos,end)=SSAHOApproximationEnum();
-			pos=find(data==6); data(pos,end)=SSAFSApproximationEnum();
+			pos=find(data==3); data(pos,end)=L1L2ApproximationEnum();
+			pos=find(data==4); data(pos,end)=HOApproximationEnum();
+			pos=find(data==5); data(pos,end)=FSApproximationEnum();
+
+			pos=find(data==6); data(pos,end)=SSAHOApproximationEnum();
 			pos=find(data==7); data(pos,end)=HOFSApproximationEnum();
-			pos=find(data==8); data(pos,end)=L1L2ApproximationEnum();
+			pos=find(data==8); data(pos,end)=SSAFSApproximationEnum();
 			WriteData(fid,'data',data,'enum',FlowequationVertexEquationEnum(),'format','DoubleMat','mattype',1);
 			data=obj.element_equation;
@@ -213,10 +223,11 @@
 			pos=find(data==1); data(pos,end)=SIAApproximationEnum();
 			pos=find(data==2); data(pos,end)=SSAApproximationEnum();
-			pos=find(data==3); data(pos,end)=HOApproximationEnum();
-			pos=find(data==4); data(pos,end)=FSApproximationEnum();
-			pos=find(data==5); data(pos,end)=SSAHOApproximationEnum();
-			pos=find(data==6); data(pos,end)=SSAFSApproximationEnum();
-			pos=find(data==7); data(pos,end)=HOFSApproximationEnum();
-			pos=find(data==8); data(pos,end)=L1L2ApproximationEnum();
+			pos=find(data==3); data(pos,end)=L1L2ApproximationEnum();
+			pos=find(data==4); data(pos,end)=HOApproximationEnum();
+			pos=find(data==5); data(pos,end)=FSApproximationEnum();
+
+			pos=find(data==6); data(pos,end)=SSAHOApproximationEnum();
+			pos=find(data==7); data(pos,end)=SSAFSApproximationEnum();
+			pos=find(data==8); data(pos,end)=HOFSApproximationEnum();
 			WriteData(fid,'data',data,'enum',FlowequationElementEquationEnum(),'format','DoubleMat','mattype',2);
 		end % }}}
Index: issm/trunk/src/m/classes/flowequation.py
===================================================================
--- issm/trunk/src/m/classes/flowequation.py	(revision 18081)
+++ issm/trunk/src/m/classes/flowequation.py	(revision 18301)
@@ -17,19 +17,22 @@
 	def __init__(self): # {{{
 		
-		self.isSIA            = 0
-		self.isSSA            = 0
-		self.isL1L2           = 0
-		self.isHO             = 0
-		self.isFS             = 0
-		self.fe_SSA           = ''
-		self.fe_HO            = ''
-		self.fe_FS            = ''
-		self.XTH_r            = 1.
-		self.XTH_theta        = 0.
-		self.vertex_equation  = float('NaN')
-		self.element_equation = float('NaN')
-		self.borderSSA        = float('NaN')
-		self.borderHO         = float('NaN')
-		self.borderFS         = float('NaN')
+		self.isSIA                          = 0
+		self.isSSA                          = 0
+		self.isL1L2                         = 0
+		self.isHO                           = 0
+		self.isFS                           = 0
+		self.fe_SSA                         = ''
+		self.fe_HO                          = ''
+		self.fe_FS                          = ''
+		self.augmented_lagrangian_r         = 1.
+		self.augmented_lagrangian_rhop      = 1.
+		self.augmented_lagrangian_rlambda   = 1.
+		self.augmented_lagrangian_rholambda = 1.
+		self.XTH_theta                      = 0.
+		self.vertex_equation                = float('NaN')
+		self.element_equation               = float('NaN')
+		self.borderSSA                      = float('NaN')
+		self.borderHO                       = float('NaN')
+		self.borderFS                       = float('NaN')
 
 		#set defaults
@@ -47,5 +50,5 @@
 		string="%s\n%s"%(string,fielddisplay(self,'fe_SSA',"Finite Element for SSA: 'P1', 'P1bubble' 'P1bubblecondensed' 'P2'"))
 		string="%s\n%s"%(string,fielddisplay(self,'fe_HO' ,"Finite Element for HO:  'P1' 'P1bubble' 'P1bubblecondensed' 'P1xP2' 'P2xP1' 'P2'"))
-		string="%s\n%s"%(string,fielddisplay(self,'fe_FS' ,"Finite Element for FS:  'P1P1' (debugging only) 'P1P1GLS' 'MINIcondensed' 'MINI' 'TaylorHood' 'XTaylorHood'"))
+		string="%s\n%s"%(string,fielddisplay(self,'fe_FS' ,"Finite Element for FS:  'P1P1' (debugging only) 'P1P1GLS' 'MINIcondensed' 'MINI' 'TaylorHood' 'LATaylorHood' 'XTaylorHood'"))
 		string="%s\n%s"%(string,fielddisplay(self,'vertex_equation',"flow equation for each vertex"))
 		string="%s\n%s"%(string,fielddisplay(self,'element_equation',"flow equation for each element"))
@@ -76,11 +79,14 @@
 			md = checkfield(md,'fieldname','flowequation.isHO','numel',[1],'values',[0,1])
 			md = checkfield(md,'fieldname','flowequation.isFS','numel',[1],'values',[0,1])
-			md = checkfield(md,'fieldname','flowequation.fe_SSA','values',['P1','P1bubble','P1bubblecondensed','P2'])
-			md = checkfield(md,'fieldname','flowequation.fe_HO' ,'values',['P1','P1bubble','P1bubblecondensed','P1xP2','P2xP1','P2','P1xP3','P2xP4'])
-			md = checkfield(md,'fieldname','flowequation.fe_FS' ,'values',['P1P1','P1P1GLS','MINIcondensed','MINI','TaylorHood','XTaylorHood','OneLayerP4z'])
+			md = checkfield(md,'fieldname','flowequation.fe_SSA','values',['P1','P1bubble','P1bubblecondensed','P2','P2bubble'])
+			md = checkfield(md,'fieldname','flowequation.fe_HO' ,'values',['P1','P1bubble','P1bubblecondensed','P1xP2','P2xP1','P2','P2bubble','P1xP3','P2xP4'])
+			md = checkfield(md,'fieldname','flowequation.fe_FS' ,'values',['P1P1','P1P1GLS','MINIcondensed','MINI','TaylorHood','XTaylorHood','OneLayerP4z','CrouzeixRaviart'])
 			md = checkfield(md,'fieldname','flowequation.borderSSA','size',[md.mesh.numberofvertices],'values',[0,1])
 			md = checkfield(md,'fieldname','flowequation.borderHO','size',[md.mesh.numberofvertices],'values',[0,1])
 			md = checkfield(md,'fieldname','flowequation.borderFS','size',[md.mesh.numberofvertices],'values',[0,1])
-			md = checkfield(md,'fieldname','flowequation.XTH_r','numel',[1],'>',0.)
+			md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_r','numel',[1],'>',0.)
+			md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rhop','numel',[1],'>',0.)
+			md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rlambda','numel',[1],'>',0.)
+			md = checkfield(md,'fieldname','flowequation.augmented_lagrangian_rholambda','numel',[1],'>',0.)
 			md = checkfield(md,'fieldname','flowequation.XTH_theta','numel',[1],'>=',0.,'<',.5)
 			if m.strcmp(md.mesh.domaintype(),'2Dhorizontal'):
@@ -111,5 +117,8 @@
 		WriteData(fid,'enum',FlowequationFeHOEnum() ,'data',StringToEnum(self.fe_HO)[0] ,'format','Integer')
 		WriteData(fid,'enum',FlowequationFeFSEnum() ,'data',StringToEnum(self.fe_FS)[0] ,'format','Integer')
-		WriteData(fid,'enum',AugmentedLagrangianREnum() ,'data',self.XTH_r ,'format','Double')
+		WriteData(fid,'enum',AugmentedLagrangianREnum(),'data',self.augmented_lagrangian_r ,'format','Double')
+		WriteData(fid,'enum',AugmentedLagrangianRhopEnum(),'data',self.augmented_lagrangian_rhop ,'format','Double')
+		WriteData(fid,'enum',AugmentedLagrangianRlambdaEnum(),'data',self.augmented_lagrangian_rlambda ,'format','Double')
+		WriteData(fid,'enum',AugmentedLagrangianRholambdaEnum(),'data',self.augmented_lagrangian_rholambda ,'format','Double')
 		WriteData(fid,'enum',AugmentedLagrangianThetaEnum() ,'data',self.XTH_theta ,'format','Double')
 		WriteData(fid,'object',self,'fieldname','borderSSA','format','DoubleMat','mattype',1)
@@ -121,10 +130,10 @@
 		data[numpy.nonzero(data==1)]=SIAApproximationEnum()
 		data[numpy.nonzero(data==2)]=SSAApproximationEnum()
-		data[numpy.nonzero(data==3)]=HOApproximationEnum()
-		data[numpy.nonzero(data==4)]=FSApproximationEnum()
-		data[numpy.nonzero(data==5)]=SSAHOApproximationEnum()
-		data[numpy.nonzero(data==6)]=SSAFSApproximationEnum()
+		data[numpy.nonzero(data==3)]=L1L2ApproximationEnum()
+		data[numpy.nonzero(data==4)]=HOApproximationEnum()
+		data[numpy.nonzero(data==5)]=FSApproximationEnum()
+		data[numpy.nonzero(data==6)]=SSAHOApproximationEnum()
 		data[numpy.nonzero(data==7)]=HOFSApproximationEnum()
-		data[numpy.nonzero(data==8)]=L1L2ApproximationEnum()
+		data[numpy.nonzero(data==8)]=SSAFSApproximationEnum()
 		WriteData(fid,'data',data,'enum',FlowequationVertexEquationEnum(),'format','DoubleMat','mattype',1)
 		data=copy.deepcopy(self.element_equation)
@@ -132,10 +141,10 @@
 		data[numpy.nonzero(data==1)]=SIAApproximationEnum()
 		data[numpy.nonzero(data==2)]=SSAApproximationEnum()
-		data[numpy.nonzero(data==3)]=HOApproximationEnum()
-		data[numpy.nonzero(data==4)]=FSApproximationEnum()
-		data[numpy.nonzero(data==5)]=SSAHOApproximationEnum()
-		data[numpy.nonzero(data==6)]=SSAFSApproximationEnum()
-		data[numpy.nonzero(data==7)]=HOFSApproximationEnum()
-		data[numpy.nonzero(data==8)]=L1L2ApproximationEnum()
+		data[numpy.nonzero(data==3)]=L1L2ApproximationEnum()
+		data[numpy.nonzero(data==4)]=HOApproximationEnum()
+		data[numpy.nonzero(data==5)]=FSApproximationEnum()
+		data[numpy.nonzero(data==6)]=SSAHOApproximationEnum()
+		data[numpy.nonzero(data==7)]=SSAFSApproximationEnum()
+		data[numpy.nonzero(data==8)]=HOFSApproximationEnum()
 		WriteData(fid,'data',data,'enum',FlowequationElementEquationEnum(),'format','DoubleMat','mattype',2)
 	# }}}
Index: issm/trunk/src/m/classes/groundingline.m
===================================================================
--- issm/trunk/src/m/classes/groundingline.m	(revision 18081)
+++ issm/trunk/src/m/classes/groundingline.m	(revision 18301)
@@ -7,5 +7,4 @@
 	properties (SetAccess=public) 
 		migration    = '';
-		melting_rate = NaN;
 	end
 	methods
@@ -23,5 +22,4 @@
             fprintf(fid, '%s\n%s\n','       <option value="None" type="string" default="false"></option>','</parameter>');
 
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n',    '<parameter key ="melting_rate" type="',          class(obj.melting_rate),'" default="',            convert2str(obj.melting_rate),'">',     '     <section name="groundingline" />','     <help> melting rate applied when previously grounded parts start floating [m/yr] </help>','</parameter>');
             fprintf(fid,'%s\n%s\n','</frame>');
         end % }}}
@@ -38,7 +36,4 @@
 			%Type of migration
 			obj.migration='None';
-
-			%basal melting rate correction: 
-			obj.melting_rate=0; 
 
 		end % }}}
@@ -64,10 +59,8 @@
 			disp(sprintf('   grounding line migration parameters:'));
 			fielddisplay(obj,'migration','type of grounding line migration: ''SoftMigration'',''AggressiveMigration'' or ''None''');
-			fielddisplay(obj,'melting_rate','melting rate applied when previously grounded parts start floating [m/yr]');
 
 		end % }}}
 		function marshall(obj,md,fid) % {{{
 			WriteData(fid,'data',StringToEnum(obj.migration),'enum',GroundinglineMigrationEnum(),'format','Integer');
-			WriteData(fid,'object',obj,'fieldname','melting_rate','format','Double');
 		end % }}}
 	end
Index: issm/trunk/src/m/classes/groundingline.py
===================================================================
--- issm/trunk/src/m/classes/groundingline.py	(revision 18081)
+++ issm/trunk/src/m/classes/groundingline.py	(revision 18301)
@@ -17,5 +17,4 @@
 	def __init__(self): # {{{
 		self.migration=''
-		self.melting_rate=float('NaN')
 
 		#set defaults
@@ -27,5 +26,4 @@
 
 		string="%s\n%s"%(string,fielddisplay(self,'migration','type of grounding line migration: ''SoftMigration'',''AggressiveMigration'',''SubelementMigration'',''SubelementMigration2'',''Contact'',''None'''))
-		string="%s\n%s"%(string,fielddisplay(self,'melting_rate','melting rate applied when previously grounded parts start floating [m/yr]'))
 		return string
 		#}}}	
@@ -34,7 +32,4 @@
 		#Type of migration
 		self.migration='None'
-
-		#basal melting rate correction: 
-		self.melting_rate=0;
 
 		return self
@@ -57,4 +52,3 @@
 	def marshall(self,md,fid):    # {{{
 		WriteData(fid,'data',StringToEnum(self.migration)[0],'enum',GroundinglineMigrationEnum(),'format','Integer')
-		WriteData(fid,'object',self,'fieldname','melting_rate','format','Double')
 	# }}}
